#ifndef PATTERNSOLVER_H
#define PATTERNSOLVER_H

#include <vector>
#include "solverbase.h"
using namespace std;


class PatternSolver : public SolverStringBase
{
    
    public:
        
        PatternSolver();
        ~PatternSolver();
        bool Solve();
        bool IterativeSolve();
        
    private:

        void AddSolver( SolverStringBase* aSolver, int aLevel );
        void DeleteSolvers();
        void CreateSolvers( int aLevel );
        bool TryLevel( int aLevel );

    private: 
        
        vector<SolverStringBase*> iSolvers;
};

#endif //PATTERNSOLVER_H
