#ifndef SOLVERBASE_H
#define SOLVERBASE_H

#include <vector>
#include <string>
#include <sstream>
using namespace std;

// Solver interface & base implementation
class SolverBase
{
	public:

		SolverBase();
		virtual ~SolverBase();
		void SetMaxIteration( int aMaxIteration );
        string SolveString() { return iSolverStr; };

    public: // interface
    
        virtual bool Solve() = 0;

    protected:
        
        // how many answers are required
        int iRequired;
        
        // Maximum iteration count. default 40
        int iMaxIteration;

        // string to store own solve stamp. for debug use.
        string iSolverStr;

};

// perhaps I should learn to use templates.. but this will do for now :)
class SolverIntBase : public SolverBase
{

    public:
        virtual void SetPattern( const vector<int>& aPattern, int aRequired );
        virtual void GetAnswer( vector<int>& aAnswer );

    protected:
        vector<int> iPattern;
        vector<int> iAnswer;
};

class SolverStringBase : public SolverBase
{
    public:
        virtual void SetPattern( const vector<string>& aPattern, int aRequired );
        virtual void GetAnswer( vector<string>& aAnswer );
    
    protected:
        vector<string> iPattern;
        vector<string> iAnswer;
};

#endif // SOLVERBASE_H
