#ifndef SPLITSOLVER_H
#define SPLITSOLVER_H

#include "solverbase.h"

class SplitSolver : public SolverStringBase
{
    enum ESplitPattern
        {
        EAlphaStart,
        EAlphaEnd,
        ENumStart,
        ENumEnd,
        EMiddle,
        EDownSlide,
        EUpSlide,
        ESplitEnd   // end mark
        };
        
	public:
		SplitSolver() {};
		~SplitSolver() {};
		bool Solve();

    private:
        bool CreateSplitArrays( vector<string>& aLeft,
                                vector<string>& aRight,
                                ESplitPattern aPattern );

        void CalculateSplitLocations( vector<int>& aSplitLen,
                                      ESplitPattern aPattern );
        void NameOfType( int aType, string& aTypeStr );
};

#endif // SPLITSOLVER_H
