#include <sstream>
#include "strtonumsolver.h"
#include "numericsolver.h"
using namespace std;

//-----------------------------------------------------------------------------
// Convert text into number and try to solve with numeric solver
// "100" => 100
//
bool StrToNumSolver::Solve()
//-----------------------------------------------------------------------------
    {
    iAnswer.clear();
    int count = iPattern.size();
    if( iMaxIteration <= 0 )
        return false;
    if( count < 3 )
        return false;
    
    // string to num
    vector<int> numbers;
	for( int i = 0; i < count; i++ )
        {
        istringstream ss( iPattern[i] );
        int num;
        if( !(ss >> num) )
            {
            // failed to convert -> not a number
            return false;
            }
        if( !ss.eof() )
            {
            // There's something else left -> not a pure number
            return false;
            }
        numbers.push_back( num );
        }

    // Solve 
    NumericSolver* slv = new NumericSolver();
    slv->SetMaxIteration( iMaxIteration );
    slv->SetPattern( numbers, iRequired );
    if( slv->Solve() )
        {
        numbers.clear();
        slv->GetAnswer( numbers );
        }
    else
        {
        return false;
        }
    
    // Num to string
    count = numbers.size();
    for( int i = 0; i < count; i++ )
        {
        stringstream answ;
        answ << numbers[i];
        string str( answ.str() );
        iAnswer.push_back( str );
        }

    iSolverStr = slv->SolveString();
    delete slv;
    return true;
    }
